# Возьмём игральную кость и бросим её.
# Она покажет нам значение от 1 до 6.
# Будем считать, что кость идеальная и каждое из значений равновероятно.
# Результатом нашего испытания является число от 1 до 6,
# появление каждого из которых равновероятно.
#
# Теперь усложняем эксперимент берём две "идеальных" кости,
# кидаем и в качестве результата эксперимента берём сумму показаний обоих костей.
# Сумма уже не имеет равновероятного распределения.
# Она принимает значения от 2 до 12 и при этом количество комбинаций,
# при которых получается число 7 составляет 6,
# в то время как способов составить любые другие варианты результата получается меньше.
# Таким образом выпадение различных испытаний нашего испытания
# (которые принимают значения от 2 до 12) уже не равновероятно.
# Если мы попытаемся нарисовать гистограмму нашего распределения,
# мы увидим пирамиду с максимумом в значении 7.
#
# Далее, усложняем наш эксперимент,
# многократно увеличивая число костей.
# В итоге, с каждым последующим увеличением числа костей
# мы будем  получать распределение комбинаций получения
# различных результатов всё более и более близким к нормальному распределению.
# А поскольку выпадение каждого результата на отдельной кости равновероятно,
# то при многократном повторении испытания при фиксированном числе костей
# гистограмма будет отражать частоту появления каждого результата.
#
# Именно в этом сила и смысл ЦПТ.
# Если на результат воздействует множество независимых мелких факторов,
# то результирующая величина будет иметь распределение близкое к нормальному.
# В этом её суть, если изложить её простым языком.

from random import randint
import matplotlib.pyplot as plt


class Dice:
    def __init__(self, sides=6):
        self.sides = sides

    def throw(self, number_of_throws=100, number_of_dices=10):
        dice_values = [0] * number_of_throws
        for i in range(number_of_throws):
            for j in range(number_of_dices):
                dice_values[i] += randint(1, self.sides)
        values_range = range(min(dice_values), max(dice_values)+1)
        return {i: dice_values.count(i) for i in values_range}


def gist_plot(data):
    sort = sorted(data)
    y = tuple(data[i] for i in sort)
    x = range(sort[0], sort[-1]+1)
    ax = plt.gca()
    ax.bar(x, y, align='center')
    ax.set_xticks(x)
    ax.set_xticklabels(x)
    plt.show()

dice = Dice()
gist_plot(dice.throw(number_of_throws=10000,number_of_dices=10))